try(destroyDialog ::tbTest)catch()
rollout tbTest "Numerical  Input"
(
	local LBL1, LBL2, LBL3, LBL4, spnTB1, spnTB2, spnTB3, valTB1, valTB2
	dotNetControl MUC "MaxCustomControls.MaxUserControl" pos:[0,0]
	
	local BG = (dotNetClass "System.Drawing.Color").FromArgb 28 28 28
	local FG = (dotNetClass "System.Drawing.Color").FromArgb 180 180 180
	local FC = (dotNetClass "System.Drawing.Color").FromArgb 0 0 0
	local BC = (dotNetClass "System.Drawing.Color").FromArgb 100 140 200
	local BS = (dotNetClass "BorderStyle").None
	local HA = (dotNetClass "HorizontalAlignment").Center
	local Fnt = dotNetObject "System.Drawing.Font" "Verdana" 8 ((dotNetClass "System.Drawing.FontStyle").bold)
	local SI = (dotNetClass "SystemInformation")
	fn DisableAccel = (enableAccelerators = false) ; fn EnableAccel = (enableAccelerators = true)
	fn defPoint x y = (dotNetObject "System.Drawing.Point" x y)
	fn labelDef dnLbl w h Pnl locX locY bgClr fgClr txt =
	(
		dnLbl.Width = w ; dnLbl.Height = h ; dnLbl.Location = defPoint (Pnl.pos.x + locX) (Pnl.pos.y + locY)	
		dnLbl.BackColor = bgClr ; dnLbl.BorderStyle = bStyle ; dnLbl.ForeColor = fgClr ; dnLbl.Text = txt
	)
	fn textboxDef dnTB w h Pnl locX locY font txt bgClr fgClr bStyle =
	(
		dnTB.Width = w ; dnTB.Height = h ; dnTB.Location = defPoint (Pnl.pos.x + locX) (Pnl.pos.y + locY)	
		dnTB.Font = font ; dnTB.Text = txt ; dnTB.BackColor = bgClr ; dnTB.ForeColor = fgClr ; dnTB.BorderStyle = bStyle
		dnTB.Multiline = dnTB.AutoSize = false ; dnTB.AcceptsTab = dnTB.AcceptsReturn = true
	)	

	local lbl1Text = "Spiner1 [min:0 ; max:1000 ; dec.Places:3] [Float]\r\nSpiner2 [min:1 ; max:100 ; dec.Places:0] [Integer]\r\nSpiner3 [min:-200 ; max:200 ; dec.Places:2] [Float]\r
NOTE: MouseWheel and KeyArrows (Up and Down)\r\nIncrement are always 1 (one)."
	local lbl2Text = "        Spiner1                  Spiner2                  Spiner3"
	local lbl3Text = "valueInput1: Fill the TextFilds with the numbers\r\n[Float or Integer] while the sum are not > 300.\r\nIf the last entry exceeds the maximum (300) then\r
it will be deleted after you press 'Return' key. Allowed\r\npunctuation marks: [.,-] without 'Brackets' and 'Space'\r\nbetween the numbers. NOTE: The input must be\r
'onedirectional' i.e. all numbers must have either a positive or negative values e.g.([-10,-20,-30,] or\r\n[10,20,30,].  abs(theSum) < 300."
	local lbl4Text = "valueInput2: Fill the TextFilds with the positive and\r\nnegative numbers [Float or Integer]. Only limitation is:\r\nthe value of a number must be in range\r
[min:-90 ; max:90]. If the value is greater than the\r\nallowed range then is replaced by zero when press\r\n'Return' key."

	local Keys1Arr = #("D0","D1","D2","D3","D4","D5","D6","D7","D8","D9","NumPad0","NumPad1","NumPad2","NumPad3","NumPad4","NumPad5","NumPad6","NumPad7", \
"NumPad8","NumPad9","Escape","Return","Back","Delete","Home","End","Left","Right","Up","Down","OemPeriod","Decimal")	
	local Keys2Arr = #("D0","D1","D2","D3","D4","D5","D6","D7","D8","D9","NumPad0","NumPad1","NumPad2","NumPad3","NumPad4","NumPad5","NumPad6","NumPad7", \
"NumPad8","NumPad9","Escape","Return","Back","Delete","Home","End","Left","Right","Up","Down","OemPeriod","Decimal","Oemcomma","OemMinus","Subtract")

	local rangeArr = #([0.0,1e3], [1,100], [-200.0,200.0]), blockChar = false, dp = 0, itm = 1, negativeDir = false
	
	fn numConvert curTxt inc dp minV maxV= 
	( 
		if curTxt as number == undefined do curTxt = "0"
		if ((findString curTxt "0") == 1 and (findString curTxt ".") == undefined) then (curTxt = "0."+curTxt)
		else if ((findString curTxt "-")== 1 and (findString curTxt "0")== 2 and (findString curTxt ".") == undefined) then (curTxt = "-0."+(trimLeft curTxt "-")) else curTxt
		local val = (curTxt as number)+inc
		local result = case of (
			(val < minV): minV
			(val>maxV): maxV
			default: val
		) ; formattedPrint (result as float) format:("0." + (dp as string) + "f") 
	) 
	fn cleanUnwanted str signeArr = 
	(
		local cnt = str.count, newstr = str[cnt], chars = "0123456789.,-" 
		for c = cnt to 1 by -1 do (if findstring chars str[c] == undefined do (str = replace str c 1 ""))
		for i in str.count-1 to 1 by -1 where not ((findItem signeArr str[i]) != 0 and str[i] == str[i+1]) do (newstr = str[i]+newstr) ; newstr
	)
	--cleanUnwaned "49.5,100,20,,nmkj.5,--40,50.kl:.,80" #(",",".","-")
	fn summerize txtInput limit: tb: =
	(
		local result = #()
		if txtInput.count == 0 then result = #("", "Put some numbers!") else
		(
			local tiArr = (filterString (cleanUnwanted txtInput #(",",".","-")) ","), sumNumArr = #(), num = 0, minus = false
			for s in tiArr where (s as number) != undefined and (s as number) != 0 do (	append sumNumArr (s as number))
			if sumNumArr.count == 0 then result = #("", "Invalid Input! Use numbers.") else 
			(
				local input = ""
				case tb of (
					(#pos): (
						if sumNumArr[1] < 0 do minus = true
						for n in sumNumArr do (num += (abs n))
						if num >= limit then
						(
							local safeVal, i = 1, m = (if minus == true then -1 else 1) ; num = 0
							while num < limit do (if num != 0 do (append input ((m * abs sumNumArr[i-1]) as string + ",")) ; num += abs sumNumArr[i] ; i+= 1)			
							num = (num - abs sumNumArr[i-1]) ; format "num = %\n" num ; safeVal = units.formatValue ((limit-num) as float)
							result = #(input, ("Your last input must be < " + safeVal))
						) else 
						(
							local input = "", m = (if minus == true then -1 else 1)
							for n in sumNumArr do (append input ((m * abs n) as string + ",")) ; result = #(input, "OK!")
						)
					)
					(#rot): (
						for n in sumNumArr do (append input (if ( abs n <= 90) then (n as string + ",") else "0.0,"))
						result = #(input, (if findString input ",0" != undefined then "Values greater than 90.0 are replaced with 0.0!" else "OK!") )
					)
				)
			)
		) ; result
	)
	--summerize "-gh,hj./,il$,,5^5,--15,g10:.,./@r" limit:300
/*//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////   FUNCTION FOR THE EVENTS   //////////*/
/*///////////   SPINNER TEXTBOXES   //////////*/
	fn spnTB_GF s e = (DisableAccel()) --GotFocus
	fn spnTB_TC s e = (print s.Text)
	fn spnTB_LF s e = --LostFocus
	(
		if s == (spnTB1) then (dp = 3 ; itm = 1) else if s == (spnTB2) then (dp = 0 ; itm = 2) else if s == (spnTB3) do (dp = 2 ; itm = 3)
		local curVal = s.Text ; if (curVal as number == undefined or s.Text.count == 0) do (if s == spnTB3 then curVal = "0.00" else curVal = rangeArr[itm].x as string)
		s.Text = numConvert curVal 0 dp rangeArr[itm].x rangeArr[itm].y ; blockChar = false ; EnableAccel()
	)
		
	fn spnTB_KD s e = --KeyDown
	(
		case s of (
			(spnTB1): ( dp = 3 ; itm = 1
				if (findItem Keys1Arr (e.keyCode.ToString())) == 0 then (blockChar = true) else
				(
					if ((e.keyCode.ToString()) == "OemPeriod" or (e.keyCode.ToString()) == "Decimal") and \
					((findString s.Text ".") != undefined and (findString s.SelectedText ".") == undefined) do (blockChar = true)
				)
			)
			(spnTB2): ( dp = 0 ; itm = 2
				if (findItem Keys1Arr (e.keyCode.ToString())) == 0 or ((e.keyCode.ToString()) == "OemPeriod") or ((e.keyCode.ToString()) == "Decimal") or \
				((s.SelectedText == s.Text or s.SelectionStart == 0) and ((e.keyCode.ToString()) == "D0" or (e.keyCode.ToString()) == "NumPad0")) do (blockChar = true)	
			)
			(spnTB3): ( dp = 2 ; itm = 3
				if ((e.keyCode.ToString()) == "Oemcomma" or (findItem Keys2Arr (e.keyCode.ToString())) == 0) then (blockChar = true) else
				(
					if ((e.keyCode.ToString()) == "OemPeriod" or (e.keyCode.ToString()) == "Decimal") and \
					((findString s.Text ".") != undefined and (findString s.SelectedText ".") == undefined) do (blockChar = true)	
					if ((e.keyCode.ToString()) == "OemMinus" or (e.keyCode.ToString()) == "Subtract") and \
					((findString s.Text "-") != undefined or s.SelectionStart != 0) and ((findString s.SelectedText "-") == undefined) do (blockChar = true)	
				)	
			)
		)
		if (e.keyCode.ToString()) == "Up" do (s.Text = numConvert s.Text 1 dp rangeArr[itm].x rangeArr[itm].y ; s.Select s.TextLength 0) --UpKey
		if (e.keyCode.ToString()) == "Down" do (s.Text = numConvert s.Text -1 dp rangeArr[itm].x rangeArr[itm].y ; s.Select s.TextLength 0) --DownKey
	)
	
	fn spnTB_KP s e = (if blockChar == true do e.Handled = true) --KeyPress

	fn spnTB_KU s e = --KeyUp
	(
		if s == (spnTB1) then (dp = 3 ; itm = 1) else if s == (spnTB2) then (dp = 0 ; itm = 2) else if s == (spnTB3) do (dp = 2 ; itm = 3)
		local curVal = s.Text ; if (curVal as number == undefined or s.Text.count == 0 or (e.keyCode.ToString()) == "Escape") do 
		((if s == spnTB1 then s.Text = "0.000" else if s == spnTB2 then s.Text = "1" else if s == spnTB3 do s.Text = "0.00") ; s.SelectAll())
		if (e.keyCode.ToString()) == "Return" do (s.Text = numConvert curVal 0 dp rangeArr[itm].x rangeArr[itm].y ; s.SelectAll()) ; blockChar = false
		if (e.keyCode.ToString()) == "Tab"	do (MUC.selectnextcontrol MUC.ActiveControl true true false true)
	)
	
	fn spnTB_MW s e = --MouseWheel
	(
		if s == (spnTB1) then (dp = 3 ; itm = 1) else if s == (spnTB2) then (dp = 0 ; itm = 2) else if s == (spnTB3) do (dp = 2 ; itm = 3)
		local mw = case of (
			((e.Delta * SI.MouseWheelScrollLines / 120) > 0): (if not keyboard.controlPressed then 1 else 10)
			((e.Delta * SI.MouseWheelScrollLines / 120) < 0): (if not keyboard.controlPressed then -1 else -10)
		) ; s.Text = numConvert s.Text mw dp rangeArr[itm].x rangeArr[itm].y ; s.SelectAll()
	)
/*///////////   VALUE INPUT TEXTBOXES   //////////*/	
	fn valTB_GF s e = (DisableAccel()) ; fn valTB_LF s e = (EnableAccel()) --GetFocus & LostFocus
		
	fn valTB_KD s e = (if (findItem Keys2Arr (e.keyCode.ToString())) == 0 do (blockChar = true))	--KeyDown	
	
	fn valTB_KP s e = (if blockChar == true do e.Handled = true) --KeyPress
		
	fn valTB_KU s e = --KeyUp
	(
		local tbtype = if s == (valTB1) then #pos else if s == (valTB2) do #rot
		if (e.keyCode.ToString()) == "Return" do 
		(
			local filterArr = summerize s.Text limit:300 tb:tbtype 
			s.Text = filterArr[1] ; if s.Text.count != 0 do s.SelectAll() ; messageBox filterArr[2] title:"TEXTBOX INFO" beep:false 
		)
		if (e.keyCode.ToString()) == "Tab"	do (MUC.selectnextcontrol MUC.ActiveControl true true false true) ; blockChar = false
		if (e.keyCode.ToString()) == "Escape" do s.Text = ""		
	)
		
	on tbTest open do 
	(
		MUC.Width = 300 ; MUC.Height = 400 ; MUC.BackColor = BG
		LBL1 =  dotNetObject "Label" ; labelDef LBL1 290 68 MUC 5 5 FG BG lbl1Text
		LBL2 =  dotNetObject "Label" ; labelDef LBL2 290 16 MUC 5 78 FG BG lbl2Text
		LBL3 =  dotNetObject "Label" ; labelDef LBL3 290 120 MUC 5 120 FG BG lbl3Text
		LBL4 =  dotNetObject "Label" ; labelDef LBL4 290 80 MUC 5 266 FG BG lbl4Text
		spnTB1 = dotNetObject "TextBox" ; textboxDef spnTB1 94 16 MUC 5 99 Fnt "0.000" BC FC BS ; spnTB1.TextAlign = HA
		spnTB2 = dotNetObject "TextBox" ; textboxDef spnTB2 94 16 MUC 103 99 Fnt "1" BC FC BS ; spnTB2.TextAlign = HA
		spnTB3 = dotNetObject "TextBox" ; textboxDef spnTB3 94 16 MUC 201 99 Fnt "0.00" BC FC BS ; spnTB3.TextAlign = HA
		valTB1 = dotNetObject "TextBox" ; textboxDef valTB1 290 16 MUC 5 245 Fnt "10,25.5,18,56.8,121.68,33," BC FC BS
		valTB2 = dotNetObject "TextBox" ; textboxDef valTB2 290 16 MUC 5 351 Fnt "-85.5,30,55,-45,88,-23.2," BC FC BS
		
		MUC.Controls.AddRange #(LBL1, LBL2, LBL3, LBL4, spnTB1, spnTB2, spnTB3, valTB1, valTB2)
		for spn in 4 to 6 do
		(
			dotnet.AddEventHandler MUC.Controls.item[spn] "KeyDown" spnTB_KD
			dotnet.AddEventHandler MUC.Controls.item[spn] "KeyPress" spnTB_KP
			dotNet.AddEventHandler MUC.Controls.item[spn] "KeyUp" spnTB_KU
			dotnet.AddEventHandler MUC.Controls.item[spn] "GotFocus" spnTB_GF
			dotnet.AddEventHandler MUC.Controls.item[spn] "LostFocus" spnTB_LF
			dotnet.AddEventHandler MUC.Controls.item[spn] "MouseWheel" spnTB_MW
			dotnet.AddEventHandler MUC.Controls.item[spn] "TextChanged" spnTB_TC			
		)
		for val in 7 to 8  do
		(
			dotnet.AddEventHandler MUC.Controls.item[val] "GotFocus" valTB_GF
			dotnet.AddEventHandler MUC.Controls.item[val] "LostFocus" valTB_LF
			dotnet.AddEventHandler MUC.Controls.item[val] "KeyDown" valTB_KD
			dotnet.AddEventHandler MUC.Controls.item[val] "KeyPress" valTB_KP
			dotNet.AddEventHandler MUC.Controls.item[val] "KeyUp" valTB_KU		
		)
	)
)
createDialog tbTest 300 372 10 110 style:#(#style_titlebar, #style_sysmenu, #style_toolwindow) --escapeEnable:true 